#ifndef __animation_h__
#define __animation_h__

#include "list.h"
#include "glut_import.h"

class Animation{
  protected:
    int StartTime,LastTime,Length,Terminated;

    virtual void execute(int ElapsedTime,int DeltaTime)=0;
    virtual void terminate(){};
  public:
    Animation(int length):Length(length){
      StartTime=-1;
      LastTime=-1;
      Terminated=0;
    };

    int getTerminated(){return Terminated;};

    int execute(){
      if (!Terminated){
        int t=glutGet(GLUT_ELAPSED_TIME);
        if (StartTime==-1){
          StartTime=t;
          LastTime=t;
        }
        if (t>StartTime+Length){
          t=StartTime+Length;
          Terminated=1;
        }
        execute(t-StartTime,t-LastTime);
        LastTime=t;
        if (Terminated)
          terminate();
      }
      return !Terminated;
    };
};

template<int AutoDelete=0> class AnimationList: public ObjectList<Animation *>{
  public:
    AnimationList(){};

    void _delete(int index){
      if (AutoDelete)
        delete getItem(index);
      ObjectList<Animation *>::_delete(index);
    };

    int execute(){
      if (Count>0 && !getItem(0)->execute())
        _delete(0);
      return Count>0;
    };
};

#endif
