#ifndef __menu_h__
#define __menu_h__

class Menu: public Handled<int,0>,public ObjectList<Menu *>{
  friend void MenuCallBack(int);
  protected:
    Menu *Parent;
    char *Name;
    int ItemCount;

    void bind(){
      glutSetMenu(getHandle());
    };

    void acquireChild(Menu *x){
      if (x->Parent!=this){
        x->setParent(NULL);
        x->Parent=this;
      }
    };

    void createHandle();
    void deleteHandle();

    void changing(){
      if (handleAllocated())
        ItemCount=Count;
    };

    void changed(){
      if ((ItemCount==0) ^ (Count==0)){
        if (Parent!=NULL)
          Parent->buildList();
        if (Count==0)
          freeHandle();
      }
      buildList();
    };

    void buildList(){
      int i;
      if (handleAllocated()){
        for (i=0;i<Count;i++)
          getItem(i)->handleNeeded();
        bind();
        for (i=ItemCount-1;i>=0;i--)
          glutRemoveMenuItem(i+1);
        for (i=0;i<Count;i++){
          if (getItem(i)->Count>0)
            glutAddSubMenu(getItem(i)->Name,getItem(i)->getHandle());
          else
            glutAddMenuEntry(getItem(i)->Name,i+1);
        }
        ItemCount=Count;
      }
    }
  public:
    Menu(char *name):Name(name),Parent(NULL){
      ItemCount=0;
    };

    Menu(Menu *parent,char *name):Name(name),Parent(parent){
      ItemCount=0;
      if (Parent!=NULL)
        Parent->add(this);
    };

    ~Menu(){
      clear();
      freeHandle();
    };

    Menu *getParent(){
      return Parent;
    };

    void setParent(Menu *parent){
      if (Parent!=parent){
        if (Parent!=NULL)
          Parent->remove(this);
        if (parent!=NULL)
          parent->add(this);
      }
    };

    void setItem(Menu *x,int index){
      Menu *y=getItem(index);
      if (y!=x){
        y->setParent(NULL);
        acquireChild(x);
        ObjectList<Menu *>::setItem(x,index);
      }
    };

    void insert(Menu *x,int index){
      ObjectList<Menu *>::insert(x,index);
      acquireChild(x);
    };

    void _delete(int index){
      getItem(index)->Parent=NULL;
      ObjectList<Menu *>::_delete(index);
    };

    virtual void onClick(){
      printf("menu click: %s\n",Name);
      if (rand() % 2==0)
        new Menu(this,"dynamic");
      else
        setParent(NULL);
    };
};

void MenuCallBack(int value){
  Menu *m=Application::currentMenu();
  if (m!=NULL)
    m->getItem(value-1)->onClick();
};

void Menu::createHandle(){
  if (Count>0){
    Handle=glutCreateMenu(MenuCallBack);
    if (Handle==Application::Menus.getCount()+1)
      Application::Menus.add(this);
    else
      Application::Menus.setItem(this,Handle-1);
    buildList();
  }
};

void Menu::deleteHandle(){
  int i;
  for (i=Count-1;i>=0;i--)
    getItem(i)->freeHandle();
  Application::Menus.setItem(NULL,Handle-1);
  glutDestroyMenu(Handle);
};

#endif

