/*
  Animation d'une thire, claire par une lampe. La lampe est gre
  par une classe fournie, la thire est gnre grce  un seul appel
  de la fonction gluSolidTeaPot() (qui se charge d'envoyer les bonnes
  coordonnes d'valuateurs  OpenGl).
 */

#include "glut_import.h"
#include "application.h"
#include "light.h"

class DemoWindow:public Window{

  Light light;

  public:
    DemoWindow():
      Window("Fentre de dmonstration",windowStyle(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE,WC_KEYBOARD | WC_IDLE)){};

    void onIdle(){
      redisplay();
    };

    void onDisplay(){
      float t=glutGet(GLUT_ELAPSED_TIME)*0.1;

      glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      gluPerspective(50,(float) getWidth()/getHeight(),0.1,10);
      gluLookAt(0,0,4,0,0,0,0,1,0);

      glMatrixMode(GL_MODELVIEW);
      glLoadIdentity();
      glRotatef(0.8*t,1,0,0);
      glRotatef(1.2*t,0,1,0);
      glRotatef(1.5*t,0,0,1);

      glutSolidTeapot(1);

      glFlush();
      glutSwapBuffers();
    };

    void onCreate(){
      printf("Appuyer sur [ESCAPE] pour quitter\n");
      glEnable(GL_DEPTH_TEST);
      glEnable(GL_LIGHTING);
      light.on();
    };
};

int main(){
  DemoWindow w;
  Application::run();
}

