#ifdef _CALLBACK
#  undef _CALLBACK
#  undef _IF
#  undef _ENDIF
#endif

#define DEBUG(x) x;
#define NODEBUG(x) ;

#if STAGE==1
#  define _CALLBACK(_debug,_name,_params,_typeparams,_group) friend void _name##Func _typeparams;
#elif STAGE==2
#  define _CALLBACK(_debug,_name,_params,_typeparams,_group) void _name##Func _typeparams;
#elif STAGE==3
#  ifdef debug
#    define _CALLBACK(_debug,_name,_params,_typeparams,_group)        \
void _name##Func_ typeparams{                                         \
  Window *w=Application::currentWindow();                             \
  _debug##(printf("calling do"## #_name ##" handler\n"))              \
  if (w!=NULL)                                                        \
    w->do##_name _params;                                             \
}
#  else
#    define _CALLBACK(_debug,_name,_params,_typeparams,_group)        \
void _name##Func _typeparams{                                         \
  Window *w=Application::currentWindow();                             \
  if (w!=NULL)                                                        \
    w->do##_name _params;                                             \
}
#  endif
#elif STAGE==4
#  define _CALLBACK(_debug,_name,_params,_typeparams,_group)          \
if ((Style.CallBacks & WC_##_group)==WC_##_group)                     \
  glut##_name##Func(&_name##Func);                                    \
else                                                                  \
  glut##_name##Func(NULL);
#else
#  error Undefined STAGE
#endif

/*  _CALLBACK(DEBUG,Joystick,(buttonMask,x,y,z),(unsigned int buttonMask,int x,int y,int z))\*/


#if (GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 13)
#  ifdef FLUSHCALLBACK
#    undef FLUSHCALLBACK
#  endif
#  define FLUSHCALLBACK                                                                      \
  _CALLBACK(DEBUG,Display,(),(),STANDARD)                                                    \
  _CALLBACK(DEBUG,Reshape,(width,height),(int width,int height),STANDARD)                    \
  _CALLBACK(DEBUG,WindowStatus,(state),(int state),STANDARD)                                 \
                                                                                             \
  _CALLBACK(DEBUG,Keyboard,(key,x,y),(unsigned char key,int x,int y),KEYBOARD)               \
  _CALLBACK(DEBUG,KeyboardUp,(key,x,y),(unsigned char key,int x,int y),KEYBOARD)             \
  _CALLBACK(DEBUG,Special,(key,x,y),(int key,int x,int y),KEYBOARD)                          \
  _CALLBACK(DEBUG,SpecialUp,(key,x,y),(int key,int x,int y),KEYBOARD)                        \
                                                                                             \
  _CALLBACK(DEBUG,Motion,(x,y),(int x,int y),MOUSE)                                          \
  _CALLBACK(DEBUG,Mouse,(button,state,x,y),(int button,int state,int x,int y),MOUSE)         \
  _CALLBACK(DEBUG,PassiveMotion,(x,y),(int x,int y),MOUSE)                                   \
  _CALLBACK(DEBUG,Entry,(state),(int state),MOUSE)                                           \
                                                                                             \
  _CALLBACK(DEBUG,ButtonBox,(button,state),(int button,int state),BUTTONBOX)                 \
                                                                                             \
  _CALLBACK(DEBUG,Dials,(dial,value),(int dial,int value),DIALS)                             \
                                                                                             \
  _CALLBACK(DEBUG,SpaceballButton,(button,state),(int button,int state),SPACEBALL)           \
  _CALLBACK(DEBUG,SpaceballMotion,(x,y,z),(int x,int y,int z),SPACEBALL)                     \
  _CALLBACK(DEBUG,SpaceballRotate,(x,y,z),(int x,int y,int z),SPACEBALL)                     \
                                                                                             \
  _CALLBACK(DEBUG,TabletButton,(button,state,x,y),(int button,int state,int x,int y),TABLET) \
  _CALLBACK(DEBUG,TabletMotion,(x,y),(int x,int y),TABLET)
#else
#  define FLUSHCALLBACK \
  _CALLBACK(DEBUG,Display,(),(),STANDARD)                                                    \
  _CALLBACK(DEBUG,Reshape,(width,height),(int width,int height),STANDARD)                    \
  _CALLBACK(DEBUG,WindowStatus,(state),(int state),STANDARD)                                 \
                                                                                             \
  _CALLBACK(DEBUG,Keyboard,(key,x,y),(unsigned char key,int x,int y),KEYBOARD)               \
  _CALLBACK(DEBUG,Special,(key,x,y),(int key,int x,int y),KEYBOARD)                          \
                                                                                             \
  _CALLBACK(DEBUG,Motion,(x,y),(int x,int y),MOUSE)                                          \
  _CALLBACK(DEBUG,Mouse,(button,state,x,y),(int button,int state,int x,int y),MOUSE)         \
  _CALLBACK(DEBUG,PassiveMotion,(x,y),(int x,int y),MOUSE)                                   \
  _CALLBACK(DEBUG,Entry,(state),(int state),MOUSE)                                           \
                                                                                             \
  _CALLBACK(DEBUG,ButtonBox,(button,state),(int button,int state),BUTTONBOX)                 \
                                                                                             \
  _CALLBACK(DEBUG,Dials,(dial,value),(int dial,int value),DIALS)                             \
                                                                                             \
  _CALLBACK(DEBUG,SpaceballButton,(button,state),(int button,int state),SPACEBALL)           \
  _CALLBACK(DEBUG,SpaceballMotion,(x,y,z),(int x,int y,int z),SPACEBALL)                     \
  _CALLBACK(DEBUG,SpaceballRotate,(x,y,z),(int x,int y,int z),SPACEBALL)                     \
                                                                                             \
  _CALLBACK(DEBUG,TabletButton,(button,state,x,y),(int button,int state,int x,int y),TABLET) \
  _CALLBACK(DEBUG,TabletMotion,(x,y),(int x,int y),TABLET)
#endif

